# define NUMBER 257
# define LSTRING 258
# define STRING 259
# define COMMENT 260
# define SLASH 261
# define COLON 262
# define BAR 263
# define BIGD 264
# define BIGN 265
# define BIGW 266
# define BIGM 267
# define BIGT 268
# define BIGO 269
# define BIGS 270
# define LITTLED 271
# define LITTLEW 272
# define LITTLEB 273
# define LITTLEM 274
# define LITTLEY 275
# define CATEGORY 276
# define DEADLINE 277
# define PARENT 278
# define CARET 279

# line 8 "todo.y"
 
/*
 * $Id: todo.y,v 3.0 1992/09/15 12:07:36 jipping Exp $
 * **********************************************************************
 *
 * Todo.y ==> YACC description of the ASCII todo database format.  
 *
 * ----------------------------------------------------------------------
 * Copyright (c) 1992 by Mike Jipping and Hope College
 *
 * Permission is granted to copy and distribute this file in modified or
 * unmodified form, for noncommercial use, provided (a) this copyright notice
 * is preserved, (b) no attempt is made to restrict redistribution of this
 * file, and (c) this file is not distributed as part of any collection whose
 * redistribution is restricted by a compilation copyright.
 * ----------------------------------------------------------------------
 *
 * Revision History:
 *
 * $Log: todo.y,v $
 * Revision 3.0  1992/09/15  12:07:36  jipping
 * Release 4.0 beta.  Added deadline recognition and changed recurring
 * parsing to accomodate verion 4.0 recurrence stuff.
 *
 * Revision 2.1  1992/07/13  14:36:58  jipping
 * Cleaned up code to avoid compilation warnings.
 *
 * Revision 2.0  1992/07/06  13:34:47  jipping
 * Initial release.
 *
 *
 */

#include "globaldefs.h"

extern struct entry_list *entry_search();
extern struct category_rec *new_category();
extern struct category_rec *cat_search();

extern int merging;

int number_value;
char string_value[80], cat[80], eid[30];
int inquotes;
int datecode, currdc;
struct day_entry *de, *tmpde;
struct entry_list *el;
struct recurrence_list *tmprl;
struct category_rec *cr, *tmpcr, *ttmpcr;
struct deadline_rec *dr;
int yylineno;

#include <malloc.h>
#include <memory.h>
#include <values.h>

#ifdef __cplusplus

#ifndef yyerror
	void yyerror(const char *);
#endif

#ifndef yylex
#ifdef __EXTERN_C__
	extern "C" { int yylex(void); }
#else
	int yylex(void);
#endif
#endif
	int yyparse(void);

#endif
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256

# line 284 "todo.y"

#include "lex.yy.c"

void yyerror(s)
char *s;
{
	fprintf(stderr,
			  "Error on line %d: %s at or around \"%s\"\n",
			  yylineno, s, yytext);
   yyerrok;
}

yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 68
# define YYLAST 154
yytabelem yyact[]={

    49,    50,    51,    47,    48,    52,    53,    42,    43,    44,
    45,    46,    56,    17,     8,    36,    24,   123,   118,   116,
   115,   112,    57,    58,   109,    59,    60,   106,    99,    61,
    54,    39,    31,     7,     6,    18,    14,   100,    62,    22,
    21,    20,   113,   121,   119,   110,   107,   104,   102,   101,
    79,    77,    76,    75,    74,    73,    72,    71,    40,    29,
    27,    41,    19,     1,    35,    28,     9,    10,    11,    93,
    55,    34,   122,   120,   117,   114,   111,   108,   105,   103,
    25,    92,    33,    26,    13,    91,    90,    89,    88,    87,
    70,    69,    68,    67,    66,    65,    64,    32,    37,    15,
    38,    30,    63,    23,    16,    12,     5,     4,     3,     2,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    78,     0,    80,    81,    82,    83,
    84,    85,    86,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    94,
    95,    96,    97,    98 };
yytabelem yypact[]={

  -243,-10000000,  -243,  -243,  -243,-10000000,-10000000,  -226,-10000000,-10000000,
-10000000,-10000000,  -266,  -227,  -218,  -222,  -247,  -218,  -197,-10000000,
-10000000,-10000000,  -198,  -230,-10000000,-10000000,-10000000,-10000000,  -263,-10000000,
  -231,  -199,  -264,  -232,  -249,-10000000,  -233,  -223,-10000000,  -218,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  -200,
  -201,  -202,  -203,  -204,  -205,-10000000,  -206,-10000000,-10000000,-10000000,
-10000000,  -218,  -207,-10000000,  -264,  -264,  -264,  -264,  -264,  -264,
  -264,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  -264,  -264,  -264,
  -264,  -264,  -234,  -224,-10000000,-10000000,-10000000,-10000000,-10000000,  -208,
  -209,-10000000,-10000000,  -210,-10000000,  -235,  -211,-10000000,  -238,  -212,
-10000000,  -241,  -217,-10000000,  -242,  -240,-10000000,  -244,  -213,-10000000,
  -214,-10000000,  -245,-10000000 };
yytabelem yypgo[]={

     0,    63,   109,   108,   107,   106,   105,   104,   103,   101,
   100,    99,    98,    62,    97,    61,    96,    95,    94,    93,
    92,    91,    90,    89,    88,    87,    86,    85,    84,    83,
    82,    81,    79,    78,    77,    76,    75,    74,    73,    72,
    71,    70,    69,    65,    64 };
yytabelem yyr1[]={

     0,     1,     1,     1,     1,     6,     2,    11,    12,     5,
     7,     7,     8,    14,     8,    15,    16,    15,    17,    15,
    18,    15,    19,    15,    20,    15,    21,    15,    22,    15,
    23,    15,    24,    15,    25,    15,    26,    15,    27,    15,
     9,    10,    13,    13,    28,    30,    31,    32,    33,    34,
    35,    36,    37,    38,    39,     3,    40,    29,    42,    41,
    41,    41,    41,    41,    43,     4,    44,    44 };
yytabelem yyr2[]={

     0,     0,     4,     4,     4,     1,    13,     1,     1,    15,
     0,     5,     0,     1,     6,     0,     1,     6,     1,     6,
     1,     6,     1,     6,     1,     6,     1,     6,     1,     6,
     1,     8,     1,     8,     1,     8,     1,     8,     1,     8,
     4,     4,     3,     3,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,    63,     1,     6,     1,    11,
     3,     3,     3,     3,     1,    10,     1,     7 };
yytabelem yychk[]={

-10000000,    -1,    -2,    -3,    -4,    -5,   277,   276,   257,    -1,
    -1,    -1,    -6,   -28,   262,   -11,    -7,   279,   262,   -13,
   259,   258,   261,    -8,   263,   -13,   -29,   257,   -43,   257,
    -9,   262,   -14,   -30,   -40,   -44,   278,   -12,   -10,   262,
   257,   -15,   271,   272,   273,   274,   275,   267,   268,   264,
   265,   266,   269,   270,   262,   -41,   261,   271,   272,   274,
   275,   262,   261,   -13,   -16,   -17,   -18,   -19,   -20,   -21,
   -22,   257,   257,   257,   257,   257,   257,   257,   -13,   257,
   -15,   -15,   -15,   -15,   -15,   -15,   -15,   -23,   -24,   -25,
   -26,   -27,   -31,   -42,   -15,   -15,   -15,   -15,   -15,   262,
   261,   257,   257,   -32,   257,   -33,   262,   257,   -34,   262,
   257,   -35,   262,   259,   -36,   262,   259,   -37,   262,   257,
   -38,   257,   -39,   262 };
yytabelem yydef[]={

     1,    -2,     1,     1,     1,     5,    44,     0,     7,     2,
     3,     4,    10,     0,     0,     0,    12,     0,     0,    64,
    42,    43,     0,     0,    13,    11,    45,    56,    66,     8,
     0,     0,    15,     0,     0,    65,     0,     0,     6,     0,
    40,    14,    16,    18,    20,    22,    24,    26,    28,     0,
     0,     0,     0,     0,     0,    57,     0,    60,    61,    62,
    63,     0,     0,    41,    15,    15,    15,    15,    15,    15,
    15,    30,    32,    34,    36,    38,    46,    58,    67,     9,
    17,    19,    21,    23,    25,    27,    29,    15,    15,    15,
    15,    15,     0,     0,    31,    33,    35,    37,    39,     0,
     0,    47,    59,     0,    48,     0,     0,    49,     0,     0,
    50,     0,     0,    51,     0,     0,    52,     0,     0,    53,
     0,    54,     0,    55 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"NUMBER",	257,
	"LSTRING",	258,
	"STRING",	259,
	"COMMENT",	260,
	"SLASH",	261,
	"COLON",	262,
	"BAR",	263,
	"BIGD",	264,
	"BIGN",	265,
	"BIGW",	266,
	"BIGM",	267,
	"BIGT",	268,
	"BIGO",	269,
	"BIGS",	270,
	"LITTLED",	271,
	"LITTLEW",	272,
	"LITTLEB",	273,
	"LITTLEM",	274,
	"LITTLEY",	275,
	"CATEGORY",	276,
	"DEADLINE",	277,
	"PARENT",	278,
	"CARET",	279,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"todo_list : /* empty */",
	"todo_list : todo_entry todo_list",
	"todo_list : deadline todo_list",
	"todo_list : category todo_list",
	"todo_entry : date_part",
	"todo_entry : date_part id_part recurring_part priority_part text_part",
	"date_part : NUMBER",
	"date_part : NUMBER SLASH NUMBER",
	"date_part : NUMBER SLASH NUMBER SLASH NUMBER",
	"id_part : /* empty */",
	"id_part : CARET estring",
	"recurring_part : /* empty */",
	"recurring_part : BAR",
	"recurring_part : BAR recur_desc",
	"recur_desc : /* empty */",
	"recur_desc : LITTLED",
	"recur_desc : LITTLED recur_desc",
	"recur_desc : LITTLEW",
	"recur_desc : LITTLEW recur_desc",
	"recur_desc : LITTLEB",
	"recur_desc : LITTLEB recur_desc",
	"recur_desc : LITTLEM",
	"recur_desc : LITTLEM recur_desc",
	"recur_desc : LITTLEY",
	"recur_desc : LITTLEY recur_desc",
	"recur_desc : BIGM",
	"recur_desc : BIGM recur_desc",
	"recur_desc : BIGT",
	"recur_desc : BIGT recur_desc",
	"recur_desc : BIGD NUMBER",
	"recur_desc : BIGD NUMBER recur_desc",
	"recur_desc : BIGN NUMBER",
	"recur_desc : BIGN NUMBER recur_desc",
	"recur_desc : BIGW NUMBER",
	"recur_desc : BIGW NUMBER recur_desc",
	"recur_desc : BIGO NUMBER",
	"recur_desc : BIGO NUMBER recur_desc",
	"recur_desc : BIGS NUMBER",
	"recur_desc : BIGS NUMBER recur_desc",
	"priority_part : COLON NUMBER",
	"text_part : COLON estring",
	"estring : STRING",
	"estring : LSTRING",
	"deadline : DEADLINE",
	"deadline : DEADLINE COLON deadline_date_part",
	"deadline : DEADLINE COLON deadline_date_part COLON NUMBER",
	"deadline : DEADLINE COLON deadline_date_part COLON NUMBER COLON NUMBER",
	"deadline : DEADLINE COLON deadline_date_part COLON NUMBER COLON NUMBER NUMBER",
	"deadline : DEADLINE COLON deadline_date_part COLON NUMBER COLON NUMBER NUMBER COLON NUMBER",
	"deadline : DEADLINE COLON deadline_date_part COLON NUMBER COLON NUMBER NUMBER COLON NUMBER COLON NUMBER",
	"deadline : DEADLINE COLON deadline_date_part COLON NUMBER COLON NUMBER NUMBER COLON NUMBER COLON NUMBER COLON STRING",
	"deadline : DEADLINE COLON deadline_date_part COLON NUMBER COLON NUMBER NUMBER COLON NUMBER COLON NUMBER COLON STRING COLON STRING",
	"deadline : DEADLINE COLON deadline_date_part COLON NUMBER COLON NUMBER NUMBER COLON NUMBER COLON NUMBER COLON STRING COLON STRING COLON NUMBER",
	"deadline : DEADLINE COLON deadline_date_part COLON NUMBER COLON NUMBER NUMBER COLON NUMBER COLON NUMBER COLON STRING COLON STRING COLON NUMBER NUMBER",
	"deadline : DEADLINE COLON deadline_date_part COLON NUMBER COLON NUMBER NUMBER COLON NUMBER COLON NUMBER COLON STRING COLON STRING COLON NUMBER NUMBER COLON",
	"deadline_date_part : NUMBER",
	"deadline_date_part : NUMBER deadline_date_rest",
	"deadline_date_rest : SLASH NUMBER",
	"deadline_date_rest : SLASH NUMBER SLASH NUMBER",
	"deadline_date_rest : LITTLED",
	"deadline_date_rest : LITTLEW",
	"deadline_date_rest : LITTLEM",
	"deadline_date_rest : LITTLEY",
	"category : CATEGORY COLON estring",
	"category : CATEGORY COLON estring parent",
	"parent : /* empty */",
	"parent : PARENT COLON estring",
};
#endif /* YYDEBUG */
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.12	93/06/07 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yynewmax * sizeof(type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		yycvtok(yylex())
/*
** yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int yycvtok(int i)
#else
int yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		yylex()
#endif/*!YYNMBCHARS*/

/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside switch should never be
	executed; yypvt is set to 0 to avoid "used before set" warning.
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto yyerrlab;
		case 2: goto yynewstate;
	}
	yypvt = 0;
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
			yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */
	goto yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			int yynewmax;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newyys = (char *)YYNEW(int);
				char *newyyv = (char *)YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
				yyerror( "yacc stack overflow" );
				YYABORT;
			}
			yymaxdepth = yynewmax;

			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
			skip_init:
				yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 5:
# line 69 "todo.y"
{
	             el = entry_search(datecode, TRUE, cr);
					 de = el->last;
					 tmprl = NULL;
					 eid[0] = '\0';
	          } break;
case 6:
# line 78 "todo.y"
{
					 currdc = (curr_year-1990)*10000 + curr_month*100 + curr_day;
					 if (!merging ||
						  !entry_text_search(string_value,
													datecode<currdc?currdc:datecode, cr)) {
						 if (tmprl == NULL) {
							 tmpde = NEW(struct day_entry);
							 tmpde->recurring_entry = FALSE;
							 tmpde->deadline = NULL;
							 tmpde->next = NULL;
							 tmpde->starting_day_code = datecode;
							 strcpy(tmpde->entry_id, eid);
							 strcpy(tmpde->text, string_value);
							 tmpde->category = cr;
							 if (number_value != 0) {
								 tmpde->priority = number_value;
								 tmpde->checked = FALSE;
							 } else {
								 tmpde->priority = default_priority;
								 tmpde->checked = TRUE;
							 }
							 if (de == NULL) {
								 el->first = el->last = tmpde;
								 tmpde->prev = NULL;
							 } else {
								 de->next = el->last = tmpde;
								 tmpde->prev = de;
							 }
						 } else {
							 strcpy(rl_tail->text, string_value);
							 rl_tail->priority = number_value;
						 }
					 }
				 } break;
case 7:
# line 114 "todo.y"
{datecode = number_value;} break;
case 8:
# line 115 "todo.y"
{datecode = datecode * 100 + number_value;} break;
case 9:
# line 116 "todo.y"
{datecode = (number_value - 90) * 10000 + datecode;} break;
case 11:
# line 120 "todo.y"
{
			    strcpy(eid, string_value);
          } break;
case 13:
# line 126 "todo.y"
{
						tmprl = NEW(struct recurrence_list);
						if (rl_head == NULL) {
							cr->rl_head = rl_head = cr->rl_tail = rl_tail = tmprl;
						} else {
							cr->rl_tail->next = rl_tail->next = tmprl;
							cr->rl_tail = rl_tail = tmprl;
						}
						tmprl->starting_day_code = datecode;
						tmprl->daily = tmprl->weekly = tmprl->biweekly = tmprl->monthly = tmprl->yearly = FALSE;
						tmprl->dow = -1;
						tmprl->dom = 0;
						tmprl->week_number =
							tmprl->number_of_weeks =
								tmprl->number_of_months = 0;
						tmprl->deadline = NULL;
						tmprl->next = NULL;
					} break;
case 16:
# line 148 "todo.y"
{tmprl->daily = TRUE;} break;
case 18:
# line 149 "todo.y"
{tmprl->weekly = TRUE;} break;
case 20:
# line 150 "todo.y"
{tmprl->biweekly = TRUE;} break;
case 22:
# line 151 "todo.y"
{tmprl->monthly = TRUE;} break;
case 24:
# line 152 "todo.y"
{tmprl->yearly = TRUE;} break;
case 26:
# line 153 "todo.y"
{tmprl->dow = 42;} break;
case 28:
# line 154 "todo.y"
{tmprl->dow = 20;} break;
case 30:
# line 155 "todo.y"
{tmprl->dow = number_value;} break;
case 32:
# line 156 "todo.y"
{tmprl->week_number = number_value;} break;
case 34:
# line 157 "todo.y"
{tmprl->number_of_weeks = number_value;} break;
case 36:
# line 158 "todo.y"
{tmprl->number_of_months = number_value;} break;
case 38:
# line 159 "todo.y"
{tmprl->dom = number_value;} break;
case 42:
# line 166 "todo.y"
{
				string_value[0] = '\0';
				sscanf(yytext, "\"%[^\"]\"", string_value);
			} break;
case 43:
# line 170 "todo.y"
{
				string_value[0] = '\0';
				strncpy(string_value, &yytext[2], strlen(yytext)-4);
				string_value[strlen(yytext)-4] = '\0';
			} break;
case 44:
# line 177 "todo.y"
{
				 dr = NEW(struct deadline_rec);
	       } break;
case 45:
# line 180 "todo.y"
{
				 dr->datecode = datecode;
			 } break;
case 46:
# line 183 "todo.y"
{
				 dr->actions = number_value;
			 } break;
case 47:
# line 186 "todo.y"
{
				 dr->delete_time = number_value;
			 } break;
case 48:
# line 189 "todo.y"
{
				 dr->delete_units = number_value;
			 } break;
case 49:
# line 192 "todo.y"
{
				 dr->priority_up_units = number_value;
			 } break;
case 50:
# line 195 "todo.y"
{
				 dr->priority_down_units = number_value;
			 } break;
case 51:
# line 198 "todo.y"
{
	          string_value[0] = '\0';
				 sscanf(yytext, "\"%[^\"]\"", string_value);
				 strcpy(dr->mail_on, string_value);
			 } break;
case 52:
# line 203 "todo.y"
{
	          string_value[0] = '\0';
				 sscanf(yytext, "\"%[^\"]\"", string_value);
				 strcpy(dr->mail_after, string_value);
			 } break;
case 53:
# line 208 "todo.y"
{
				 dr->move_time = number_value;
			 } break;
case 54:
# line 211 "todo.y"
{
				 dr->move_units = number_value;
			 } break;
case 55:
# line 214 "todo.y"
{
				 if (tmprl == NULL) {
					 tmpde->deadline = dr;
				 } else {
					 rl_tail->deadline = dr;
				 }
			 } break;
case 56:
# line 223 "todo.y"
{datecode = number_value;} break;
case 58:
# line 225 "todo.y"
{datecode = datecode * 100 + number_value;} break;
case 59:
# line 226 "todo.y"
{
								datecode = (number_value - 90) * 10000 + datecode;
								dr->relative = FALSE;
							} break;
case 60:
# line 230 "todo.y"
{datecode = datecode * 10; dr->relative = TRUE;} break;
case 61:
# line 231 "todo.y"
{datecode = datecode * 10 + 1; dr->relative = TRUE;} break;
case 62:
# line 232 "todo.y"
{datecode = datecode * 10 + 2; dr->relative = TRUE;} break;
case 63:
# line 233 "todo.y"
{datecode = datecode * 10 + 3; dr->relative = TRUE;} break;
case 64:
# line 236 "todo.y"
{
	          if (category_head == NULL) cr = NULL;
	          strcpy(cat, string_value);
			 } break;
case 66:
# line 243 "todo.y"
{
	         if ( merging &&
					 (tmpcr = cat_search(category_head, string_value))) {
					cr = tmpcr;
					entry_head = cr->entry_head;
					entry_tail = cr->entry_tail;
					rl_head = cr->rl_head;
					rl_tail = cr->rl_tail;
				} else {
					if (category_head == NULL) {
						cr = NULL;
					} else {
						for (cr=category_head; cr->next!=NULL; cr=cr->next) ;
					}
					cr = new_category(string_value, cr, FALSE);
					entry_head = entry_tail = (struct entry_list *) NULL;
					rl_head = rl_tail = (struct recurrence_list *) NULL;
				}
         } break;
case 67:
# line 262 "todo.y"
{
				tmpcr = cat_search(category_head, string_value);
	         if ( merging &&
					 (ttmpcr = cat_search(category_head, cat))) {
					cr = ttmpcr;
					entry_head = cr->entry_head;
					entry_tail = cr->entry_tail;
					rl_head = cr->rl_head;
					rl_tail = cr->rl_tail;
				} else {
					if (tmpcr->subcats == NULL) {
						cr = new_category(cat, tmpcr, TRUE);
					} else {
						cr = new_category(cat, cr, FALSE);
					}
					entry_head = entry_tail = (struct entry_list *) NULL;
					rl_head = rl_tail = (struct recurrence_list *) NULL;
				}
				cr->parent = tmpcr;
		   } break;
	}
	goto yystack;		/* reset registers in driver code */
}

